/*
   Run plugin for FAR Manager
*/

#include "plugin.hpp"

#if defined(__GNUC__)
#ifdef __cplusplus
extern "C"{
#endif
  BOOL WINAPI DllMainCRTStartup(HANDLE hDll, DWORD dwReason, LPVOID lpsrcerved);
#ifdef __cplusplus
};
#endif

BOOL WINAPI DllMainCRTStartup(HANDLE hDll, DWORD dwReason, LPVOID lpsrcerved)
{
  (void) lpsrcerved;
  (void) dwReason;
  (void) hDll;
  return TRUE;
}
#endif

static struct PluginStartupInfo Info;
struct FarStandardFunctions FSF;

int WINAPI _export GetMinFarVersion(void)
{
  return MAKEFARVERSION(1,70,2087);
}

void WINAPI _export SetStartupInfo(const struct PluginStartupInfo *psInfo)
{
  ::Info=*psInfo;
  ::FSF=*psInfo->FSF;
  ::Info.FSF=&::FSF;
  LPSTR lpFARCmd=GetCommandLine();
  while(FSF.LStrnicmp(lpFARCmd,"/run ",5)&&*lpFARCmd)lpFARCmd++;
  while(*lpFARCmd!=' '&&*lpFARCmd)lpFARCmd++;
  if(*lpFARCmd)
  {
    FSF.Trim(lpFARCmd);
    if(*lpFARCmd=='\"')lpFARCmd++;
    int l=lstrlen(lpFARCmd);
    if(lpFARCmd[l-1]=='\"')lpFARCmd[l-1]=0x00;
    psInfo->Control(INVALID_HANDLE_VALUE,FCTL_SETCMDLINE,(void*)lpFARCmd);
    KeySequence KeySeq;
    DWORD Sequence=0x0D;
    //KeySeq.Flags=KSFLAGS_DISABLEOUTPUT;
    KeySeq.Count=1;
    KeySeq.Sequence=&Sequence;
    Info.AdvControl(Info.ModuleNumber,ACTL_POSTKEYSEQUENCE,&KeySeq);
  }
}

void WINAPI _export GetPluginInfo(struct PluginInfo *Info)
{
  Info->StructSize=sizeof(*Info);
  Info->Flags=PF_PRELOAD;
}
